﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace howto_mean_median_sets
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void btnGo_Click(object sender, EventArgs e)
        {
            lstMatches.Items.Clear();
            lblNumMatches.Text = "";
            Cursor = Cursors.WaitCursor;
            Refresh();

            int max = int.Parse(txtMax.Text);

            List<List<int>> list1 = Triples(max);
            foreach (List<int> triple1 in list1)
            {
                int sum1 = triple1.Sum();
                if (sum1 % 3 != 0) continue;
                int mean1 = sum1 / 3;
                int median1 = triple1[1];
                if (mean1 == median1) continue;

                foreach (List<int> triple2 in list1)
                {
                    if ((triple1[0] == triple2[0]) &&
                        (triple1[1] == triple2[1]) &&
                        (triple1[2] == triple2[2]))
                        continue;

                    int sum2 = triple2.Sum();
                    if (sum2 % 3 != 0) continue;
                    int mean2 = sum2 / 3;
                    int median2 = triple2[1];
                    if (mean2 == median2) continue;

                    if ((mean1 == median2) && (mean2 == median1))
                    {
                        // Find sets where the mean of one is the
                        // median of the other and vice versa.
                        lstMatches.Items.Add(
                            TripleString(triple1) + '\t' +
                            TripleString(triple2));
                        Console.WriteLine(
                            TripleString(triple1) + '\t' +
                            triple1.Sum() / 3 + '\t' +
                            triple1[1].ToString() + '\t' +

                            TripleString(triple2) + '\t' +
                            triple2.Sum() / 3 + '\t' +
                            triple2[1].ToString());
                        Refresh();
                    }
                }
            }

            lblNumMatches.Text = lstMatches.Items.Count.ToString();
            Cursor = Cursors.Default;
        }

        private List<List<int>> Triples(int max)
        {
            List<List<int>> results = new List<List<int>>();

            for (int i = 1; i < max; i++)
                for (int j = i + 1; j < max; j++)
                    for (int k = j + 1; k < max; k++)
                    {
                        results.Add(new List<int>(new int[] { i, j, k }));
                    }
            return results;
        }

        private List<List<int>> Fives(int max)
        {
            List<List<int>> results = new List<List<int>>();
            for (int i = 1; i < max; i++)
                for (int j = i + 1; j < max; j++)
                    for (int k = j + 1; k < max; k++)
                        for (int l = k + 1; l < max; l++)
                            for (int m = l + 1; m < max; m++)
                            {
                                results.Add(new List<int>(new int[] { i, j, k, l, m }));
                            }
            return results;
        }

        private string TripleString(List<int> list)
        {
            return "{" + list[0].ToString() +
                ", " + list[1].ToString() +
                ", " + list[2].ToString() + "}";
        }
    }
}
